package de.hft.stuttgart.quality.adapter.types;

import javax.xml.namespace.QName;

import org.xmlobjects.annotation.XMLElement;
import org.xmlobjects.builder.ObjectBuildException;
import org.xmlobjects.serializer.ObjectSerializeException;
import org.xmlobjects.stream.XMLReadException;
import org.xmlobjects.stream.XMLReader;
import org.xmlobjects.stream.XMLWriteException;
import org.xmlobjects.stream.XMLWriter;
import org.xmlobjects.xml.Attributes;
import org.xmlobjects.xml.Element;
import org.xmlobjects.xml.Namespaces;

import de.hft.stuttgart.quality.QualityADEModule;
import de.hft.stuttgart.quality.adapter.properties.ComponentListPropertyAdapter;
import de.hft.stuttgart.quality.model.properties.ComponentListProperty;
import de.hft.stuttgart.quality.model.types.MultipleComponentsError;

@XMLElement(name = "GE_S_MULTIPLE_CONNECTED_COMPONENTS", namespaceURI = QualityADEModule.NAMESPACE_URI)
public class MultipleComponentsErrorAdapter extends AbstractSolidErrorAdapter<MultipleComponentsError> {

	@Override
	public MultipleComponentsError createObject(QName name, Object parent) throws ObjectBuildException {
		return new MultipleComponentsError();
	}

	@Override
	public void buildChildObject(MultipleComponentsError object, QName name, Attributes attributes, XMLReader reader)
			throws ObjectBuildException, XMLReadException {
		if (!QualityADEModule.NAMESPACE_URI.equals(name.getNamespaceURI())) {
			return;
		}
		switch (name.getLocalPart()) {
		case "components" -> object.getComponents().add(reader.getObjectUsingBuilder(ComponentListPropertyAdapter.class));
		default -> super.buildChildObject(object, name, attributes, reader);
		}
	}
	
	@Override
	public Element createElement(MultipleComponentsError object, Namespaces namespaces)
			throws ObjectSerializeException {
		return Element.of(QualityADEModule.NAMESPACE_URI, "GE_S_MULTIPLE_CONNECTED_COMPONENTS");
	}

	@Override
	public void writeChildElements(MultipleComponentsError object, Namespaces namespaces, XMLWriter writer)
			throws ObjectSerializeException, XMLWriteException {
		super.writeChildElements(object, namespaces, writer);
		for (ComponentListProperty clp : object.getComponents()) {
			writer.writeElementUsingSerializer(Element.of(QualityADEModule.NAMESPACE_URI, "components"), clp,
					ComponentListPropertyAdapter.class, namespaces);
		}
	}
}
